=== debian/changelog ===
ros-r2b3-demo-nodes-cpp (0.0.3-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- William Woodall <william@osrfoundation.org>  Wed, 13 Sep 2017 23:21:41 -0000
