=== debian/control ===
Source: ros-r2b3-demo-nodes-cpp
Section: misc
Priority: extra
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-r2b3-ament-cmake, ros-r2b3-ament-cmake-nose, ros-r2b3-ament-lint-auto, ros-r2b3-ament-lint-common, ros-r2b3-example-interfaces, ros-r2b3-launch, ros-r2b3-launch-testing, ros-r2b3-rclcpp, ros-r2b3-rcutils, ros-r2b3-rmw-implementation, ros-r2b3-rmw-implementation-cmake, ros-r2b3-rosidl-default-generators, ros-r2b3-rosidl-default-runtime, ros-r2b3-sensor-msgs, ros-r2b3-std-msgs, ros-r2b3-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-r2b3-demo-nodes-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-r2b3-example-interfaces, ros-r2b3-rclcpp, ros-r2b3-rcutils, ros-r2b3-rmw-implementation, ros-r2b3-rosidl-default-runtime, ros-r2b3-sensor-msgs, ros-r2b3-std-msgs, ros-r2b3-ros-workspace
Description: C++ nodes which were previously in the ros2/examples repository but are now just used for demo purposes.
